__version__ = "0.1"
__author__ = "Redouane Hajjar <redouane.hajjar@chimie.uvsq.fr>"
__date__ = "Dec 2009"


from math import pow
from struct import unpack, pack
import os
import time

################################################################################
class FileWriter:
    """
    write bruker fid file from ASCII file
    """
    #---------------------------------------------------------------------------
    def __init__(self, filein, filepathout, bytord, size):
        """
        filein: ascii data file
        filepathout: encoded data (fid)
        bytord: 0 or 1
        size: data size
        """
        self.filein = filein
        self.filepathout = filepathout
        self.bytord = bytord
        self.size = size
        
        # read file (ascii)
        try:
            file = open(os.path.join(self.filein), "r")
        except:
            raise("failed to load")
            MSG("failed to load", "Error:")
        lines = file.readlines()
        file.close()
                
        """
        ATTENTION !!!
        """
        start = 0       #filein contains only values (without comments)
        self.data = []

        for index in range(self.size/2):     #two column file
            val = lines[index+start].split("\n")[0].split(" ")
            self.data.append(val[0])
            self.data.append(val[1]) 
            print index, val[0], val[1]
        
        # write fid (binary)
        if self.bytord == 1:
            self.writeFidBE()
        elif  self.bytord == 0:
            self.writeFidLE()
        
        MSG("job is done!", "FileWriter") #For topspin

    #---------------------------------------------------------------------------
    def writeFidBE(self):
        """
        writes bruker fid file
        utf-16-be (big endian)
        """
        file = open(os.path.join(self.filepathout, "fid"), 'wb')
        # encode
        for valdec in self.data: 
            file.write( pack( 'i', int(valdec)) )
        file.close()
        
    #---------------------------------------------------------------------------
    def writeFidLE(self):
        """
        writes bruker fid file
        utf-16-be (little endian)
        """
        file = open(os.path.join(self.filepathout, "fid"), 'wb')
        # encode and reverse (CDCA = ACDC)
        for valdec in self.data: 
            file.write( pack( 'i', int(valdec))[::-1])
        file.close()
        
################################################################################
result = DATASET_DIALOG("www.pascal-man.com", CURDATA())
filepath = result[3] + "/data/" + result[4] + "/nmr/" + result[0] + "/" + result[1]
filein = filepath + "/denoised.txt"
bytordout = int(GETPAR("BYTORDA"))
size = int(GETPAR("TDeff"))
FileWriter(filein, filepath, bytordout, size)
sizeInChart = GETPAR("TDeff")
PUTPAR("status TDeff", sizeInChart)
PUTPAR("TD", sizeInChart)
PUTPAR("status TD", sizeInChart)
################################################################################